<?php

use App\Helpers\uuid;
use App\Models\Notification\Notification;
use App\Models\Settings\Setting;
use Carbon\Carbon as Carbon;
use Illuminate\Support\Str;
use App\Models\Access\User\User;

/**
 * Henerate UUID.
 *
 * @return uuid
 */
function generateUuid() {
    return uuid::uuid4();
}

if (!function_exists('homeRoute')) {

    /**
     * Return the route to the "home" page depending on authentication/authorization status.
     *
     * @return string
     */
    function homeRoute() {
        if (access()->allow('view-backend')) {
            return 'admin.dashboard';
        } elseif (auth()->check()) {
            return 'frontend.user.dashboard';
        }

        return 'frontend.index';
    }

}

/*
 * Global helpers file with misc functions.
 */
if (!function_exists('app_name')) {

    /**
     * Helper to grab the application name.
     *
     * @return mixed
     */
    function app_name() {
        return config('app.name');
    }

}

if (!function_exists('access')) {

    /**
     * Access (lol) the Access:: facade as a simple function.
     */
    function access() {
        return app('access');
    }

}

if (!function_exists('history')) {

    /**
     * Access the history facade anywhere.
     */
    function history() {
        return app('history');
    }

}

if (!function_exists('gravatar')) {

    /**
     * Access the gravatar helper.
     */
    function gravatar() {
        return app('gravatar');
    }

}

if (!function_exists('includeRouteFiles')) {

    /**
     * Loops through a folder and requires all PHP files
     * Searches sub-directories as well.
     *
     * @param $folder
     */
    function includeRouteFiles($folder) {
        $directory = $folder;
        $handle = opendir($directory);
        $directory_list = [$directory];

        while (false !== ($filename = readdir($handle))) {
            if ($filename != '.' && $filename != '..' && is_dir($directory . $filename)) {
                array_push($directory_list, $directory . $filename . '/');
            }
        }

        foreach ($directory_list as $directory) {
            foreach (glob($directory . '*.php') as $filename) {
                require $filename;
            }
        }
    }

}

if (!function_exists('getRtlCss')) {

    /**
     * The path being passed is generated by Laravel Mix manifest file
     * The webpack plugin takes the css filenames and appends rtl before the .css extension
     * So we take the original and place that in and send back the path.
     *
     * @param $path
     *
     * @return string
     */
    function getRtlCss($path) {
        $path = explode('/', $path);
        $filename = end($path);
        array_pop($path);
        $filename = rtrim($filename, '.css');

        return implode('/', $path) . '/' . $filename . '.rtl.css';
    }

}

if (!function_exists('settings')) {

    /**
     * Access the settings helper.
     */
    function settings() {
        // Settings Details
        $settings = Setting::latest()->first();
        if (!empty($settings)) {
            return $settings;
        }
    }

}

if (!function_exists('createNotification')) {

    /**
     * create new notification.
     *
     * @param  $message    message you want to show in notification
     * @param  $userId     To Whom You Want To send Notification
     *
     * @return object
     */
    function createNotification($message, $userId) {
        $notification = new Notification();

        return $notification->insert([
                    'message' => $message,
                    'user_id' => $userId,
                    'type' => 1,
                    'created_at' => Carbon::now(),
        ]);
    }

}

if (!function_exists('escapeSlashes')) {

    /**
     * Access the escapeSlashes helper.
     */
    function escapeSlashes($path) {
        $path = str_replace('\\', DIRECTORY_SEPARATOR, $path);
        $path = str_replace('//', DIRECTORY_SEPARATOR, $path);
        $path = trim($path, DIRECTORY_SEPARATOR);

        return $path;
    }

}

if (!function_exists('getMenuItems')) {

    /**
     * Converts items (json string) to array and return array.
     */
    function getMenuItems($type = 'backend', $id = null) {
        $menu = new \App\Models\Menu\Menu();
        $menu = $menu->where('type', $type);

        if (!empty($id)) {
            $menu = $menu->where('id', $id);
        }
        $menu = $menu->first();
        if (!empty($menu) && !empty($menu->items)) {
            return json_decode($menu->items);
        }

        return [];
    }

}


if (!function_exists('getMenuItemsJSON')) {

    /**
     * Converts items (json string) to array and return array.
     */
    function getMenuItemsJSON($type = 'backend', $id = null) {
        $menu = new \App\Models\Menu\Menu();
        $menu = $menu->where('type', $type);
        if (!empty($id)) {
            $menu = $menu->where('id', $id);
        }
        $menu = $menu->first();
        if (!empty($menu) && !empty($menu->items)) {
            return $menu->items;
        }

        return [];
    }

}



if (!function_exists('getRouteUrl')) {

    /**
     * Converts querystring params to array and use it as route params and returns URL.
     */
    function getRouteUrl($url, $url_type = 'route', $separator = '?') {
        $routeUrl = '';
        if (!empty($url)) {
            if ($url_type == 'route') {
                if (strpos($url, $separator) !== false) {
                    $urlArray = explode($separator, $url);
                    $url = $urlArray[0];
                    parse_str($urlArray[1], $params);
                    $routeUrl = route($url, $params);
                } else {
                    $routeUrl = route($url);
                }
            } else {
                $routeUrl = $url;
            }
        }

        return $routeUrl;
    }

}

if (!function_exists('renderMenuItems')) {

    /**
     * render sidebar menu items after permission check.
     */
    function renderMenuItems($items, $viewName = 'backend.layouts.sections.sidebar-item') {
        foreach ($items as $item) {
            // if(!empty($item->url) && !Route::has($item->url)) {
            //     return;
            // }
            if (!empty($item->view_permission_id)) {
                if (access()->allow($item->view_permission_id)) {
                    echo view($viewName, compact('item'));
                }
            } else {
                echo view($viewName, compact('item'));
            }
        }
    }

}

if (!function_exists('isActiveMenuItem')) {

    /**
     * checks if current URL is of current menu/sub-menu.
     */
    function isActiveMenuItem($item, $separator = '?') {
        $item->clean_url = $item->url;
        if (strpos($item->url, $separator) !== false) {
            $item->clean_url = explode($separator, $item->url, -1);
        }
        if (Active::checkRoutePattern($item->clean_url)) {
            return true;
        }
        if (!empty($item->children)) {
            foreach ($item->children as $child) {
                $child->clean_url = $child->url;
                if (strpos($child->url, $separator) !== false) {
                    $child->clean_url = explode($separator, $child->url, -1);
                }
                if (Active::checkRoutePattern($child->clean_url)) {
                    return true;
                }
            }
        }

        return false;
    }

}

if (!function_exists('checkDatabaseConnection')) {

    /**
     * @return bool
     */
    function checkDatabaseConnection() {
        try {
            DB::connection()->reconnect();

            return true;
        } catch (Exception $ex) {
            return false;
        }
    }

}

if (!function_exists('renderMenu')) {

    /**
     * render sidebar menu items after permission check.
     */
    function renderMenu($items, $viewName = 'backend.includes.partials.sidebar-item') {
        foreach ($items as $item) {
            // if(!empty($item->url) && !Route::has($item->url)) {
            //     return;
            // }
            if (!empty($item->view_permission_id)) {
                if (access()->allow($item->view_permission_id)) {
                    echo view($viewName, compact('item'));
                }
            } else {
                echo view($viewName, compact('item'));
            }
        }
    }

}

/*
  |--------------------------------------------------------------------------
  | Helper Function Active
  |--------------------------------------------------------------------------
  |
 */
if (!function_exists('active_class')) {

    /**
     * Get the active class if the condition is not falsy.
     *
     * @param        $condition
     * @param string $activeClass
     * @param string $inactiveClass
     *
     * @return string
     */
    function active_class($condition, $activeClass = 'active', $inactiveClass = '') {
        return app('active')->getClassIf($condition, $activeClass, $inactiveClass);
    }

}

if (!function_exists('if_uri')) {

    /**
     * Check if the URI of the current request matches one of the specific URIs.
     *
     * @param array|string $uris
     *
     * @return bool
     */
    function if_uri($uris) {
        return app('active')->checkUri($uris);
    }

}

if (!function_exists('if_uri_pattern')) {

    /**
     * Check if the current URI matches one of specific patterns (using `str_is`).
     *
     * @param array|string $patterns
     *
     * @return bool
     */
    function if_uri_pattern($patterns) {
        return app('active')->checkUriPattern($patterns);
    }

}

if (!function_exists('if_query')) {

    /**
     * Check if one of the following condition is true:
     * + the value of $value is `false` and the current querystring contain the key $key
     * + the value of $value is not `false` and the current value of the $key key in the querystring equals to $value
     * + the value of $value is not `false` and the current value of the $key key in the querystring is an array that
     * contains the $value.
     *
     * @param string $key
     * @param mixed  $value
     *
     * @return bool
     */
    function if_query($key, $value) {
        return app('active')->checkQuery($key, $value);
    }

}

if (!function_exists('if_route')) {

    /**
     * Check if the name of the current route matches one of specific values.
     *
     * @param array|string $routeNames
     *
     * @return bool
     */
    function if_route($routeNames) {
        return app('active')->checkRoute($routeNames);
    }

}

if (!function_exists('if_route_pattern')) {

    /**
     * Check the current route name with one or some patterns.
     *
     * @param array|string $patterns
     *
     * @return bool
     */
    function if_route_pattern($patterns) {
        return app('active')->checkRoutePattern($patterns);
    }

}

if (!function_exists('if_route_param')) {

    /**
     * Check if the parameter of the current route has the correct value.
     *
     * @param $param
     * @param $value
     *
     * @return bool
     */
    function if_route_param($param, $value) {
        return app('active')->checkRouteParam($param, $value);
    }

}

if (!function_exists('if_action')) {

    /**
     * Return 'active' class if current route action match one of provided action names.
     *
     * @param array|string $actions
     *
     * @return bool
     */
    function if_action($actions) {
        return app('active')->checkAction($actions);
    }

}

if (!function_exists('if_controller')) {

    /**
     * Check if the current controller class matches one of specific values.
     *
     * @param array|string $controllers
     *
     * @return bool
     */
    function if_controller($controllers) {
        return app('active')->checkController($controllers);
    }

}

if (!function_exists('current_controller')) {

    /**
     * Get the current controller class.
     *
     * @return string
     */
    function current_controller() {
        return app('active')->getController();
    }

}

if (!function_exists('current_method')) {

    /**
     * Get the current controller method.
     *
     * @return string
     */
    function current_method() {
        return app('active')->getMethod();
    }

}

if (!function_exists('current_action')) {

    /**
     * Get the current action string.
     *
     * @return string
     */
    function current_action() {
        return app('active')->getAction();
    }

}

/*
  |--------------------------------------------------------------------------
  | Helper Function
  |--------------------------------------------------------------------------
  |
 */

/**
 * Return Opening Hours
 * @return type
 */
function openingHours() {
    return [
        '07:00:00' => '07:00',
        '07:30:00' => '07:30',
        '08:00:00' => '08:00',
        '08:30:00' => '08:30',
        '09:00:00' => '09:00',
        '09:30:00' => '09:30',
        '10:00:00' => '10:00',
        '10:30:00' => '10:30',
        '11:00:00' => '11:00',
        '11:30:00' => '11:30',
        '12:00:00' => '12:00',
        '12:30:00' => '12:30',
    ];
}

/**
 * Return Closing Hours
 * @return type
 */
function closingHours() {
    return [
        '13:00:00' => '13:00',
        '13:30:00' => '13:30',
        '14:00:00' => '14:00',
        '14:30:00' => '14:30',
        '15:00:00' => '15:00',
        '15:30:00' => '15:30',
        '16:00:00' => '16:00',
        '16:30:00' => '16:30',
        '17:00:00' => '17:00',
        '17:30:00' => '17:30',
        '18:00:00' => '18:00',
        '18:30:00' => '18:30',
        '19:00:00' => '19:00',
        '19:30:00' => '19:30',
        '20:00:00' => '20:00',
        '20:30:00' => '20:30',
        '21:00:00' => '21:00',
        '21:30:00' => '21:30',
        '22:00:00' => '22:00',
        '22:30:00' => '22:30',
        '23:00:00' => '23:00',
        '23:30:00' => '23:30',
        '24:00:00' => '24:00',
    ];
}

if (!function_exists('getTiming')):

    function getTiming($listing, $day, $type) {
        if (isset($listing) && $listing->timings) :
            foreach ($listing->timings as $timing):
                if (isset($timing->name) && $timing->name == $day):
                    return $timing->$type;
                endif;
            endforeach;
        endif;
        return null;
    }

endif;


if (!function_exists('getTimingDays')):

    function getTimingDays() {
        $days = [
            'monday' => 'Monday',
            'tuesday' => 'Tuesday',
            'wednesday' => 'Wednesday',
            'thursday' => 'Thursday',
            'friday' => 'Friday',
            'saturday' => 'Saturday',
            'sunday' => 'Sunday',
        ];
        $timing = [];
        foreach ($days as $key => $day) {
            $timing[$key]['opening'] = date('H:i:s');
            $timing[$key]['closing'] = date('H:i:s');
        }
        return $timing;
    }

endif;

if (!function_exists('getMedia')):

    function getMedia($listing, $name) {
        if (isset($listing) && $listing->social_network) :
            foreach ($listing->social_network as $network):
                if ($network->network_type == $name) {
                    return $network->network_url;
                }
            endforeach;
        endif;
        return null;
    }

endif;
if (!function_exists('categoryCount')):

    function categoryCount($cat_id = null) {
        if (!is_null($cat_id)) {
            $r = DB::select('SELECT  COUNT(`ezzy_categories_id`) as "count" FROM ezzy_listing_categories  WHERE `ezzy_categories_id` =' . $cat_id);
            if ($r && count($r)) {
                return $r[0]->count;
            }
        }
    }

endif;

if (!function_exists('categoryIcons')):

    function categoryIcons() {
        return [
            'icon-coffee-cup' => 'Hotels',
            'icon-dish' => 'Restaurants',
            'icon-tyre' => 'Shopping',
            'icon-car' => 'Automobile',
            'lar la-building' => 'Real Estate',
            'icon-video-camera' => 'Cinema',
        ];
    }

endif;
if (!function_exists('regions')):

    function regions() {
        return [
            'london' => 'London',
            'peris' => 'Peris',
            'california' => 'California',
            'miami' => 'Miami',
            'la' => 'Los Angles',
            'new-york' => 'New York',
        ];
    }

endif;

if (!function_exists('settings')) {

    /**
     * Access the settings helper.
     */
    function settings() {
        // Settings Details
        $settings = Setting::latest()->first();
        if (!empty($settings)) {
            return $settings;
        }
    }

}
if (!function_exists('getLocation')):

    function getLocation($listing, $name) {
        if (isset($listing) && $listing->locations) :
            foreach ($listing->locations as $location):
                if (isset($location->$name)) {
                    return $location->$name;
                }
            endforeach;
        endif;
        return null;
    }

endif;
if (!function_exists('timingStatus')):

    function timingStatus($timings) {
        $carbonDate = new Carbon();
        $carbonDate->timezone = 'America/New_York';
        $time = $carbonDate->format('H:i:s');
        $day = Carbon::parse($carbonDate)->format('l');
        foreach ($timings as $timing):
            if ($timing->name === Str::lower($day)):
                if (($time >= $timing->open_time) && ($time <= $timing->close_time)):
                    return 'open';
                else:
                    return 'close';
                endif;
            endif;
        endforeach;
    }

endif;
if (!function_exists('getStates')):

    function getStates() {
        $s = config('states');
        return json_decode($s, true);
    }

endif;
if (!function_exists('getSelectedLocation')):

    function getSelectedLocation($regions, $state) {
        if ((!is_null($regions) && $regions->region == $state)):
            return 'selected';
        endif;
        return false;
    }

endif;



if (!function_exists('role')):

    function role($key = 'id') {
        if (!is_null(access()->user())):
            return (access()->user()->roles[0][$key]);
        endif;
        return false;
    }

endif;

/*
  |--------------------------------------------------------------------------
  | Listing Function
  |--------------------------------------------------------------------------
  |
 */

function banner($cat) {
    $filepath = public_path('storage/images/listing/');
    $faker = \Faker\Factory::create();
//    return $faker->image('public/storage/images/listing', 640, 480, null, false);
    return $faker->image($filepath, 400, 300, null, false);
//    return $faker->image('storage/images/blog/', 400, 300, null, false);
}

function categories() {
    $cat = [];
    $faker = \Faker\Factory::create();
    $cat[] = $faker->numberBetween(1, 6);
    return $cat;
}

function tags() {
    $faker = \Faker\Factory::create();
    for ($i = 1; $i <= 2; $i++):
        $tags[] = $faker->numberBetween(1, 2);
    endfor;
    return $tags;
}

function img($count = 1) {
    $filepath = public_path('storage/images/blog/');
    if (!File::exists($filepath)) {
        File::makeDirectory($filepath);
    }

    $faker = \Faker\Factory::create();
    $image = $faker->image($filepath, 400, 300, null, false);
    if ($image) {
        return $image;
    }
    return 'default-image.jpeg';
}

function social_media() {
    $faker = \Faker\Factory::create();
    $social['facebook'] = 'https://facebook.com/' . Str::slug($faker->text(40));
    $social['twitter'] = 'https://twitter.com/' . Str::slug($faker->text(40));
    $social['instagram'] = 'https://instagram.com/' . Str::slug($faker->text(40));
    return $social;
}

function gallery($count = 1) {
    $filepath = public_path('storage/images/listing/gallery');
    $gallery = [];
    for ($i = 1; $i <= 5; $i++):
        $faker = \Faker\Factory::create();
        $gallery[] = $faker->image($filepath, 400, 300, null, false);
    endfor;
    return $gallery;
}

function faqs() {
    $faq = [];
    $faker = \Faker\Factory::create();
    for ($i = 0; $i <= 5; $i++):
        $faq['question'][] = $faker->text(50);
        $faq['answer'][] = $faker->text(150);
    endfor;
    return $faq;
}

function locations() {
    $faker = \Faker\Factory::create();
    $location['address'] = $faker->address;
    $location['region'] = ($faker->numberBetween(1, 6));
    $location['longitude'] = lats()->lng;
    $location['latitude'] = lats()->lat;
    $location['postal_code'] = $faker->postcode;
    return $location;
}

function lats() {
    $json = file_get_contents(public_path('schema/states.json'));
    $ar = json_decode($json);
    return getrandomelement($ar->{'Alaska'}->Coordinates);
}

function getrandomelement($array) {
    $pos = rand(0, sizeof($array) - 1);
    $res = $array[$pos];
    if (is_array($res))
        return getrandomelement($res);
    else
        return $res;
}

function daysArray() {
    return array(
        'Monday',
        'Tuesday',
        'Wednesday',
        'Thursday',
        'Friday',
        'Saturday',
        'Sunday',
    );
}

function timings() {

    $days = getTimingsDays();
    $timing = [];
    foreach ($days as $day) {
        $timing[Str::lower($day)]['opening'] = date('H:i:s');
        $timing[Str::lower($day)]['closing'] = date('H:i:s');
    }
    return $timing;
}

function audio() {
    $audio = [];
    $faker = \Faker\Factory::create();
    for ($i = 0; $i <= 3; $i++):
        $audio['soundcloud'][] = 'http://' . Str::slug($faker->text(40)) . '.com';
        $audio['youtube'][] = 'http://' . Str::slug($faker->text(40)) . '.com';
        $audio['saavan'][] = 'http://' . Str::slug($faker->text(40)) . '.com';
    endfor;
    return $audio;
}

function video() {
    $video = [];
    $faker = \Faker\Factory::create();
    for ($i = 0; $i <= 3; $i++):
        $video['vimeo'][] = 'http://' . Str::slug($faker->text(40)) . '.com';
        $video['youtube'][] = 'http://' . Str::slug($faker->text(40)) . '.com';
        $video['dailymotion'][] = 'http://' . Str::slug($faker->text(50)) . '.com';
    endfor;
    return $video;
}

if (!function_exists('getTimingsDays')):

    function getTimingsDays($number = null) {
        return days();
    }

endif;

function days() {
    return [
        'monday' => 'Monday',
        'tuesday' => 'Tuesday',
        'wednesday' => 'Wednesday',
        'thursday' => 'Thursday',
        'friday' => 'Friday',
        'saturday' => 'Saturday',
        'sunday' => 'Sunday',
    ];
}

function convertToObject($array) {
    $object = new stdClass();
    foreach ($array as $key => $value) {
        if (is_array($value)) {
            $value = convertToObject($value);
        }
        $object->$key = $value;
    }
    return $object;
}

if (!function_exists('blogCategoriesIcons')):

    function blogCategoriesIcons() {
        return [
            'icon-coffee-cup' => 'Hotels',
            'icon-dish' => 'Restaurants',
            'icon-tyre' => 'Shopping',
            'icon-car' => 'Automobile',
            'lar la-building' => 'Real Estate',
            'icon-video-camera' => 'Cinema',
        ];
    }

endif;

function userMedia($name) {
    if (access()->user()->profile):
        $socialMedia = json_decode(access()->user()->profile->social_media);
        return isset($socialMedia->$name) ? $socialMedia->$name : '';
    endif;
    return null;
}

/**
 * Return Rating
 * @param type $listing
 * @param type $type
 * @return type
 */
function rating($listing, $type = 'friendly') {
    switch ($type):
        case 'friendly':
            $rating = ($listing->averageFriendlyRating(2));
            return (null !== $rating) ? $rating : 0;
        case 'quality':
            $rating = $listing->averageQualityRating(2);
            return (null !== $rating) ? $rating : 0;
        case 'pricing':
            $rating = ($listing->averagePricingRating(2));
            return (null !== $rating) ? $rating : 0;
        case 'average':
            $rating = $listing->averageRating(2);
            return (null !== $rating) ? $rating : 0;

        default:
            return 0;
    endswitch;
}

function getUserById($id) {
    $user = User::find($id);
    return $user;
}

/**
 * Check if bookmarked
 * @param type $listing
 * @return string
 */
function is_bookmarked($listing) {
    $id = $listing->id;
    $owner = $listing->owner->id;
    $bookmarks = $listing->owner->bookmarks;
    $is_bookmarked = collect($bookmarks)->filter(function($bookmark) use($id, $owner) {
        return ($bookmark->model_id == $id &&
                $bookmark->user_id == $owner);
    });
    if (count($is_bookmarked) && access()->user()):
        return 'active';
    endif;
    return '';
}

function bodyAttrs() {
    foreach (config('backend.map.body_attrs') as $attr => $value):
        echo $attr . '="' . $value . '"';
    endforeach;
}
